// C Source File
// Created 9/15/2004; 7:33:56 PM

#include "circuit.h"

register component *first asm("a4");
component *last;
coord cursorloc;
register component *cursor asm("a3");
#ifndef SIMONLY
component *wiretarget;
unsigned char wiretargetinput;
#endif
unsigned char cycle; //11
char componentsprites[NUMBEROFTYPES][8] = COMPONENTSPRITES;
char outputsprites[2][8] = OUTPUTSPRITES;
char solidsprite[8]={0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF};
char wirepoints[NUMBEROFTYPES][5][2] = WIREPOINTS;
char inputs[NUMBEROFTYPES][2] = INPUTS;
#if defined(SAVE)||defined(LOAD)
char file[9]={'c','i','r','c','s','a','v','0',0};
#endif
char redraw;
char simulate;

// Main Function
void _main(void)
{
	void *a3save = cursor;
	first=0;
	last=0;
	cursorloc=(coord){0,0};
	cursor=0;
#ifndef SIMONLY
	wiretarget=0;
	wiretargetinput=0;
#endif
	cycle=0;

	void *virtual;
	char render=0;
	short i,key;
#ifndef SIMONLY
	component *tobemoved=0;
	component *tobedeleted=0;
	component *loop;
#endif

	short oldOSInitKeyInitDelay=OSInitKeyInitDelay(96);
	short oldOSInitBetweenKeyDelay=OSInitBetweenKeyDelay(32);

	if (!(virtual=malloc(LCD_SIZE))) {
		printf("Insufficient Memory");
		anykey();
		return;
	}

	memset(virtual,0,LCD_SIZE);
	
#ifdef STARTUPSCREEN
	CLRSCR("Digital Logic\n"
	       "Circuit Simulator\n"
	       "Version 0.9\n"
	       "by Clarence Risher\n"
	       "sparr0@gmail.com\n"
	       "\n"
	       "Press [APPS] for help\n");
	anykey();
#else
	CLRSCR("");
#endif
	
#ifdef LOAD
	if(!loadfile('0')){
		printf("\nCannot load Autosave\n");
	}
	anykey();
#endif
	
	simulate=1;
	
	do{

		cursor=first;
		while(cursor) {
			if (cursor->loc.x==cursorloc.x&&cursor->loc.y==cursorloc.y) break;
			cursor=cursor->next;
		}

		coord cursordelta=(coord){0,0};

		if(simulate) {
			cycle++;
			if((loop=first))
				while(loop){
					simulatenode(loop);
					loop=loop->next;
				}
			simulate=0;
			render=1;
		}
		if(render
#ifndef SIMONLY
		||tobemoved
#endif
		) {
			PortSet (virtual, 239, 127);
			ClrScr();
			loop=first;
			while(loop){
				for(i=0;i<4;i++) {
					if(loop->input[i]&&loop->inputs>i)
						DrawLine(
							loop->loc.x*8+wirepoints[loop->ctype][i+1][0],
							loop->loc.y*8+wirepoints[loop->ctype][i+1][1],
							loop->input[i]->loc.x*8+wirepoints[loop->input[i]->ctype][0][0],
							loop->input[i]->loc.y*8+wirepoints[loop->input[i]->ctype][0][1],
							loop->input[i]->output?A_THICK1:A_NORMAL
						);
				}
				Sprite8_OR(loop->loc.x*8,loop->loc.y*8,8,componentsprites[loop->ctype],virtual);
				if(loop->label) DrawChar((loop->loc.x+loop->labelloc.x)*8+1,(loop->loc.y+loop->labelloc.y)*8,loop->label,A_NORMAL);
				if(loop->output) Sprite8_OR(loop->loc.x*8,loop->loc.y*8,8,outputsprites[(OUTPUTSPRITETYPES>>loop->ctype)&1],virtual);
				loop=loop->next;
			}
			PortRestore();
			render=0;
			redraw=1;
		}
		if(redraw) {
			clrscr();
			LCD_restore(virtual);
			redraw=0;
		}
		
		drawcursor();
		key=ngetchx()&~((short)2048);
		drawcursor();

#ifdef LOAD
		if(key=='(') {
			CLRSCR("Open file #(0-9)?");
			i=0;
			key=ngetchx();
			if(key>='0'&&key<='9') {
#ifdef SAVE
				if(!savefile('0')){
					printf("Autosave failed, continue?");
					i=ngetchx();
				} else anykey();
#endif
				if(i==0||i=='y'){
					if(!loadfile(key)){
						printf("\nLoad Failed!\n");
						simulate=1;
					}
					anykey();
				}
			}
		}
		else
#endif
#ifdef SAVE
		if(key==')') {
			CLRSCR("Save file #(0-9)?");
			key=ngetchx();
			if(key>='0'&&key<='9') {
				if(!savefile(key)){
					printf("Save failed!");
				}
				anykey();
			}
		}
		else
#endif
		if(key==KEY_UP) {
			cursordelta.y=11;
		}
		else if(key==KEY_DOWN) {
			cursordelta.y=1;
		}
		else if(key==KEY_LEFT) {
			cursordelta.x=19;
		}
		else if(key==KEY_RIGHT) {
			cursordelta.x=1;
		}
		else if(key==KEY_F1&&cursor) {
			cursor->output=!cursor->output;
			simulate=1;
		}
#ifndef SIMONLY
		else if(key==KEY_F2) {
			if(!cursor)
				cursor=newnode();
			cursor->ctype+=1;
			cursor->ctype%=NUMBEROFTYPES;
			cursor->inputs=max(min(cursor->inputs,inputs[cursor->ctype][1]),inputs[cursor->ctype][0]);
			cursor->thiscycle=cycle-1;
			if(wiretarget==cursor) wiretarget=0;
			simulate=1;
		}
		else if(key==KEY_F3) {
			if(wiretarget==cursor)
				wiretargetinput=(wiretargetinput+1)%(cursor->inputs);
			else if (cursor->inputs){
				wiretarget=cursor;
				wiretargetinput=0;
			} else wiretarget=0;
		}
		else if(key==KEY_F5) {
			if(!cursor) {
				cursor=newnode();
				cursor->ctype=0;
				cursor->inputs=4;
			}
			if(wiretarget) {
				wiretarget->input[wiretargetinput]=(cursor->ctype||cursor->inputs)?cursor:0;
				if(wiretarget->inputs<=wiretargetinput) wiretarget->inputs=wiretargetinput+1;
				wiretarget=0;
				wiretargetinput=-1;
				simulate=1;
			} else {
				if((cursor->ctype)&&(cursor->inputs>1)) {
					component* temp;
					temp=cursor->input[0];
					for(i=0;i<cursor->inputs-1;i++)
						cursor->input[i]=cursor->input[i+1];
					cursor->input[cursor->inputs-1]=temp;
					render=1;
				}
			}
		}
		else if(key==KEY_F6&&cursor) {
			cursor->inputs+=1;
			if(cursor->inputs>inputs[cursor->ctype][1]) cursor->inputs=inputs[cursor->ctype][0];
			simulate=1;
		}
		else if(key==KEY_STO) {
			if(tobemoved)
				tobemoved=0;
			else if(cursor)
				tobemoved=cursor;
		}
		else if(key==KEY_CLEAR&&cursor) {
			if(tobedeleted!=cursor) {
				tobedeleted=cursor;
			} else {
				loop=first;
				while(loop){
					for(i=0;i<4;i++)
						if (loop->input[i]==cursor) loop->input[i]=0;
					loop=loop->next;
				}
				if (tobedeleted->prev&&tobedeleted->next) {
					tobedeleted->prev->next=tobedeleted->next;
					tobedeleted->next->prev=tobedeleted->prev;
				} else if (tobedeleted->prev) {
					tobedeleted->prev->next=0;
					last=tobedeleted->prev;
				} else if (tobedeleted->next) {
					tobedeleted->next->prev=0;
					first=tobedeleted->next;
				} else {
					first=0;
					last=0;
				}
				free(tobedeleted);
				tobedeleted=0;
				simulate=1;
			}
		}
#ifdef LABELING
		else if (key=='t'&&cursor) {
			CLRSCR("Old label '");
			putchar(cursor->label);
			printf("'\nNew label?");
			cursor->label=ngetchx();
			if (cursor->label==KEY_ENTER) {
				cursor->label=0;
			} else {
				printf("\nNew label '");
				putchar(cursor->label);
				printf("'\n"
				       "Display where?\n"
				       "7 8 9\n"
				      " \\|/\n"
				       "4-5-6\n"
				       " /|\\\n"
				       "1 2 3");
				while((i=ngetchx())<'1'||i>'9');
				cursor->labelloc.x=-1+(i-'1')%3;
				cursor->labelloc.y=1-(i-'1')/3;
			}
			render=1;
		}
#endif //end #ifdef LABELING
#endif //end #ifndef SIMONLY
#ifdef INFOSCREEN
		else if (key=='|'&&cursor) {
			CLRSCR("");
			printf("Component Info\n"
			       "Loc: (%d,%d)\n"
			       "Type: %02d\n"
			       "Output: %d\n"
			       "Inputs: %d\n"
			       "Label: %c (%d,%d)\n"
			       "\n",
				     cursor->loc.x,cursor->loc.y,
				     cursor->ctype,
				     cursor->output,
				     cursor->inputs,
				     cursor->label,cursor->labelloc.x,cursor->labelloc.y);
#ifdef INFOICON
//draw an enlarged component icon
			int x,y,j,k;
			for(x=0;x<8;x++)
				for(y=0;y<8;y++)
					for(j=0;j<5;j++)
						for(k=0;k<5;k++)
							if((componentsprites[cursor->ctype][y])&(128>>x)) EXT_SETPIX(LCD_MEM,120+x*5+j,y*5+k);
#endif
			anykey();
		}
#endif
#ifdef HELPSCREEN
		else if (key==KEY_APPS) {
			CLRSCR("F1     - Toggle Button\n"
				     "F2     - Change Component\n"
				     "F3/F5  - Start/End Wire\n"
				     "F6     - More Inputs\n"
				     "Clear  - Delete Component\n"
				     "t      - Label Component\n"
				     "|      - Component Info\n"
				     "Sto    - Grab Component\n"
				     "( / )  - Load/Save File\n");
			anykey();
		}
#endif		
		else if (key==KEY_ESC) {
			return;
		}
		else {
			simulate=1;
		}
	cursorloc.y=(cursorloc.y+cursordelta.y)%12;
	cursorloc.x=(cursorloc.x+cursordelta.x)%20;
#ifndef SIMONLY
	if(tobemoved)
		tobemoved->loc=cursorloc;
#endif

	}while(key!=KEY_ENTER);
	
#ifdef SAVE
	if(!savefile('0')) anykey();
#endif

	cleanup();

	OSInitKeyInitDelay(oldOSInitKeyInitDelay);
	OSInitBetweenKeyDelay(oldOSInitBetweenKeyDelay);
	
	free(virtual);
	cursor=a3save;
}

short simulatenode(component *node){
	short i;
	if (!node) return 0;
	if (node->thiscycle==cycle) return node->output;
	node->thiscycle=cycle;
	short input;
	short output=0;
	for(i=0;i<node->inputs;i++) {
		input=simulatenode(node->input[i]);
		output+=input;
	}
	switch (node->ctype) {
		case WIRE:
		case OUTPUTLED:
			node->output=(output>0);
			break;
		case GATEAND:
			node->output=(output==node->inputs);
			break;
		case GATEOR:
			node->output=(output>0);
			break;
		case GATEXOR:
			node->output=(output==1);
			break;
		case GATENAND:
			node->output=(output!=node->inputs);
			break;
		case GATENOR:
			node->output=!(output);
			break;
		case GATEXNOR:
			node->output=(output!=1);
			break;
		case GATENOT:
			node->output=!output;
			break;
		case CLOCK:
			node->output=!(node->output);
			break;
		case MUX:
			node->output=node->input[node->input[2]->output]->output;
			break;
	}
	return node->output;
}

void drawcursor() {
	Sprite8_XOR(cursorloc.x*8,cursorloc.y*8,8,solidsprite,LCD_MEM);
#ifndef SIMONLY
	if (wiretarget) drawwireline();
#endif
}

#ifndef SIMONLY
void drawwireline() {
	DrawLine(
	cursorloc.x*8+wirepoints[cursor?cursor->ctype:0][0][0],
	cursorloc.y*8+wirepoints[cursor?cursor->ctype:0][0][1],
	wiretarget->loc.x*8+wirepoints[wiretarget->ctype][wiretargetinput+1][0],
	wiretarget->loc.y*8+wirepoints[wiretarget->ctype][wiretargetinput+1][1],	
	A_XOR);
}
#endif

#ifdef LOAD
//read in a saved file
short loadfile(unsigned char c) {
	cleanup();
	FILE *infile;
	component *loop;
	file[7]=c;
	short i,id=1;
	unsigned char o;
	CLRSCR("Loading");
	if ((infile=fopen(file,"rb"))) {
		while((!feof(infile))) {
			printf(".");
			loop=newnode();
			loop->id=id++;
			o=fgetc(infile);
			loop->ctype=o&15;
			loop->inputs=(o>>4)&7;
			loop->output=o>>7;
			for(i=0;i<4;i++)
				loop->inputid[i]=fgetc(infile);
			o=fgetc(infile);
			loop->loc.y=o/20;
			loop->loc.x=o%20;
			loop->label=fgetc(infile);
			o=fgetc(infile);
			loop->labelloc.x=(o&15)-1;
			loop->labelloc.y=((o>>4)&15)-1;
		}
		fclose(infile);
		loop=first;
		while(loop) {
			for(i=3;i>=0;i--) {
				component* search;
				search=first;
				while(search) {
					if (search->id==loop->inputid[i]) break;
					search=search->next;
				}
				loop->input[i]=search;
			}
			loop=loop->next;
		}
	} else {
		printf("\nError opening file.");
		return 0;
	}
	printf("\n");
	simulate=1;
	return 1;
}
#endif

#ifdef SAVE
//save the circuit state
short savefile(unsigned char c) {
	if(!first) {
		CLRSCR("Not saving empty circuit\n");
		anykey();
		return 1;
	}
	FILE *outfile;
	component *loop;
	file[7]=c;
	short i;
	unsigned char o,id=1;
	CLRSCR("Saving\n");
	if ((outfile=fopen(file,"wb"))) {
		loop=first;
		while(loop) {
			loop->id=id++;
			loop=loop->next;
		}
		loop=first;
		while(loop) {
			o=(loop->ctype)|((loop->inputs)<<4)|((loop->output)<<7);
			fputc(o,outfile);
			for(i=0;i<4;i++) {
				if(loop->input[i]) {
					fputc(loop->input[i]->id,outfile);
				} else {
					fputc(0,outfile);
				}
			}
			o=(loop->loc.y)*20+(loop->loc.x);
			fputc(o,outfile);
			fputc(loop->label,outfile);
			o=(loop->labelloc.x+1)|(loop->labelloc.y+1)<<4;
			fputc(o,outfile);
			loop=loop->next;
		}
		fclose(outfile);
	} else {
		printf("Error opening file.\n");
		return 0;
	}
	return 1;
}
#endif

void CLRSCR(const char *text) {
	clrscr();
	printf(text);
	redraw=1;
}

void cleanup() {
	component *loop=first;
	while(loop){
		if (loop->prev) free(loop->prev);
		if (!loop->next) {
			free(loop);
			loop=0;
		} else {
			loop=loop->next;
		}
	}
	first=0;
	last=0;
}

void anykey() {
	printf("Press any key");
	ngetchx();
}

component* newnode() {
	component *temp=malloc(sizeof(component));
	memset(temp,0,sizeof(*temp));
	if(last) {
		last->next=temp;
		temp->prev=last;
		last=temp;
	} else {
		first=temp;
		last=temp;
		temp->prev=0;
	}
	temp->ctype=-1;
	temp->thiscycle=cycle;
	temp->loc=cursorloc;
	return temp;
}
